.Dd April 7, 1993
.Dt SCREEN 
.Os 386BSD
.Sh NAME
.Nm screen
.Nd pc display interface
.Sh DESCRIPTION

Access to the
.Ar virtual consoles 
are obtained through the device files
tty01 - ttynn in /dev. 
Each of these files correspond to a seperate
virtual console.
All virtual console devices can be open at once, but only one is 
active at a time. The active virtual console "owns" the keyboard and
display screen.
.Pp
Output to a virtual console that not currently is on the display is
saved in a buffer that holds a "screenfull" (normally 25) lines.
Any output written to 
.Ar /dev/console 
(the original console device) is echoed to /dev/tty01.
.Pp
To switch between the virtual consoles one uses the sequence 
.Ar ALT+Fn
, which means hold down ALT and press one of the function keys. The 
virtual console with the same number as the function key is then
selected as the current virtual console, and given exclusive use of
the keyboard and display. This switch sequence can be changed via
the keyboard mapping ioctl call (see keyboard.man)
.Pp
The number of virtual consoles is changeable in the system config 
file, and need recompilation of the kernel to take any effect. The
default is 12.
The console understands a subset of the ANSI x3.64 character 
sequences. For compatibility with the old pccons, the PC3 character
sequences is also supported.
.Pp
.Bd -literal 
ANSI	Seq	Function				Termcap entry
======= ======= =====================================   ==============

CUU	E[nA	move cursor up n lines			up (ku)

CUD	E[nB	move cursor down n lines		do (kd)

CUF	E[nC	move cursor right n characters		nd (kr)

CUB	E[nD	move cursor left n characters		bs (kl)

HPA	E[n`	move cursor character position n	--

HPR	E[na	move cursor right n characters 		--

VPA	E[nd	move cursor to line n			--

VPR	E[ne	move cursor down n lines		--

CPL	E[nF	move cursor to start of line,		--
		n lines up

CNL	E[nF	move cursor to start of line,		--
		n lines down

CUP	E[y;xH	Move cursor to x, y			cm

HVP	E[y;xf	Move cursor to x, y			--

CBT	E[nZ	Move cursor back n tab stops		bt

IL	E[nL	Insert n blank lines			al

ICH	E[n@	Insert n blank characters		ic

DL	E[nM	Delete n lines				dl

DCH	E[nP	Delete n characters			dc

ED	E[nJ	Erase part or all of display:		cd
		n=0 from cursor to end of display,
		n=1 from begin of display to cursor,
		n=2 entire display.

EL	E[nK	Erase part or all of line:		ce
		n=0 from cursor to end of line,
		n=1 from begin of line to cursor,
		n=2 entire line.

ECH	E[nX	Erase n characters			--

SU	E[nS	Scroll display n lines up (forward)	sf

SD	E[nT	Scroll display n lines down (reverse)	sr


SGR	E[nm	Set character attributes:		--
		n= 0 normal attribute (all off)
		n= 1 bold (highlight)
		n= 4 underscore (if supported by HW)
		n= 5 blink (if supported by HW)
		n= 7 reverse 
		n=3X set foreground color (see table)
		n=4X set background color (see table)

		   X=0 black 	X=1 red
		   X=2 green	X=3 brown
		   X=4 blue	X=5 magenta
		   X=6 cyan 	X=7 white


--	E[=p;dB	Set bell pitch (p) and duration (d),	--
			picth is in units of 840 nS, 
			duration is units of 0,1 S.

--	E[=s:eC	Set cursor start and end scanline,	--
			start on line s, end on line e.

--	E[=nA	Set the border color to color n
		(see table) (if supported by HW)

--	E[=cF	set normal foreground color to n 	--
		(see table)

--	E[=cG	set normal background color to n 	--
		(see table)

--	E[=cH	set reverse foreground color to n 	--
		(see table)

--	E[=cI	set reverse background color to n 	--
		(see table)

		   n= 0 black	n= 8 grey
		   n= 1 blue	n= 9 light blue
		   n= 2 green	n=10 light green
		   n= 3 cyan	n=11 light cyan
		   n= 4 red	n=12 light red
		   n= 5 magenta n=13 light magenta
		   n= 6 brown	n=14 yellow
		   n= 7 white	n=15 light white

note: the first E in the sequences stands for ESC (0x1b)

.Ed
.Pp
.Sh AUTHOR
 Sren Schmidt 
 Email: (baukno@login.dkuug.dk -or- sos@kmd-ac.dk)

